Index: /XIOS/dev/XIOS_DEV_CMIP6/src/io/nc4_data_output.cpp
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/src/io/nc4_data_output.cpp	(revision 1508)
+++ /XIOS/dev/XIOS_DEV_CMIP6/src/io/nc4_data_output.cpp	(revision 1509)
@@ -1183,6 +1183,6 @@
         axis->computeWrittenCompressedIndex(comm_file);
        
-        int zoom_size  = (MULTI_FILE == SuperClass::type) ? axis->zoom_n
-                                                          : axis->global_zoom_n;
+        int zoom_size  = (MULTI_FILE == SuperClass::type) ? axis->zoom_n.getValue()
+                                                          : axis->global_zoom_n.getValue();
 
         int zoom_count = axis->zoom_n;                                                 
Index: /XIOS/dev/XIOS_DEV_CMIP6/src/node/domain.cpp
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/src/node/domain.cpp	(revision 1508)
+++ /XIOS/dev/XIOS_DEV_CMIP6/src/node/domain.cpp	(revision 1509)
@@ -1801,9 +1801,9 @@
              int iend = ibegin + ni -1;
              int jend = jbegin + nj -1;
-             zoom_ibegin = global_zoom_ibegin > ibegin ? global_zoom_ibegin : ibegin;
+             zoom_ibegin = global_zoom_ibegin > ibegin ? global_zoom_ibegin.getValue() : ibegin;
              int zoom_iend  = global_zoom_iend < iend ? zoom_iend : iend ;
              zoom_ni     = zoom_iend-zoom_ibegin+1 ;
 
-             zoom_jbegin = global_zoom_jbegin > jbegin ? global_zoom_jbegin : jbegin ;
+             zoom_jbegin = global_zoom_jbegin > jbegin ? global_zoom_jbegin.getValue() : jbegin ;
              int zoom_jend   = global_zoom_jend < jend ? zoom_jend : jend;
              zoom_nj     = zoom_jend-zoom_jbegin+1;
@@ -2594,9 +2594,9 @@
     int zoom_jend_glob = global_zoom_jbegin + global_zoom_nj - 1;
 
-    zoom_ibegin.setValue(global_zoom_ibegin > ibegin ? global_zoom_ibegin : ibegin);
+    zoom_ibegin.setValue(global_zoom_ibegin > ibegin ? global_zoom_ibegin.getValue() : ibegin);
     int zoom_iend = zoom_iend_glob < iend ? zoom_iend_glob : iend ;
     zoom_ni.setValue(zoom_iend-zoom_ibegin+1);
 
-    zoom_jbegin.setValue(global_zoom_jbegin > jbegin ? global_zoom_jbegin : jbegin);
+    zoom_jbegin.setValue(global_zoom_jbegin > jbegin ? global_zoom_jbegin.getValue() : jbegin);
     int zoom_jend = zoom_jend_glob < jend ? zoom_jend_glob : jend ;
     zoom_nj.setValue(zoom_jend-zoom_jbegin+1);
@@ -2657,6 +2657,6 @@
   
     if (nbMaskInd != globalLocalIndexMap_.size())
-      info (0) << "If the domain " << this->getDomainOutputName() <<" does not have overlapped region between processes."
-               << "Something must be wrong with mask index "<< std::endl;
+      info (0) << "If domain " << this->getDomainOutputName() <<" does not have overlapped regions between processes "
+               << "something must be wrong with mask index "<< std::endl;
 
     nbMaskInd = globalLocalIndexMap_.size();
@@ -2733,6 +2733,6 @@
     
       if (nbLonInd != globalLocalIndexMap_.size())
-        info (0) << "If the domain " << this->getDomainOutputName() <<" does not have overlapped region between processes."
-                 << "Something must be wrong with longitude index "<< std::endl;
+        info (0) << "If domain " << this->getDomainOutputName() <<" does not have overlapped regions between processes "
+                 << "something must be wrong with longitude index "<< std::endl;
 
       nbLonInd = globalLocalIndexMap_.size();
@@ -2817,6 +2817,6 @@
     
       if (nbLatInd != globalLocalIndexMap_.size())
-        info (0) << "If the domain " << this->getDomainOutputName() <<" does not have overlapped region between processes."
-                << "Something must be wrong with latitude index "<< std::endl;
+        info (0) << "If domain " << this->getDomainOutputName() <<" does not have overlapped regions between processes "
+                << "something must be wrong with latitude index "<< std::endl;
 
       nbLatInd = globalLocalIndexMap_.size();
@@ -2899,6 +2899,6 @@
 
       if (nbAreaInd != globalLocalIndexMap_.size())
-        info (0) << "If the domain " << this->getDomainOutputName() <<" does not have overlapped region between processes."
-                 << "Something must be wrong with area index "<< std::endl;
+        info (0) << "If domain " << this->getDomainOutputName() <<" does not have overlapped regions between processes "
+                 << "something must be wrong with area index "<< std::endl;
 
       nbAreaInd = globalLocalIndexMap_.size();
Index: /XIOS/dev/XIOS_DEV_CMIP6/src/type/type_decl.cpp
===================================================================
--- /XIOS/dev/XIOS_DEV_CMIP6/src/type/type_decl.cpp	(revision 1508)
+++ /XIOS/dev/XIOS_DEV_CMIP6/src/type/type_decl.cpp	(revision 1509)
@@ -3,5 +3,5 @@
 #include "type_ref_impl.hpp"
 #include "type_specialisation.hpp"
-#include <string> ;
+#include <string>
 #include "date.hpp"
 #include "xios_spl.hpp"